#ifndef KSATINSTANCE_H
#define KSATINSTANCE_H

#include <vector>
#include <iostream>

namespace satlab
{
    
class KSATinstance
{
public:
    using LITERAL = int;
    using CLAUSE = std::vector<LITERAL>;
    using MODEL = std::vector<LITERAL>;
    
    KSATinstance() = default;
    ~KSATinstance() = default;
    
    KSATinstance(const KSATinstance& other) = default;
    KSATinstance(KSATinstance&& other) = default;
    
    KSATinstance& operator=(const KSATinstance& other) = default;
    KSATinstance& operator=(KSATinstance&& other) = default;
    
    void addClause(const CLAUSE& clause);
    void addClause(CLAUSE&& clause);
    
    const std::vector<CLAUSE>& getClauses() const;
    
    void setId(const std::string& id);
    void setId(std::string&& id);
    
    const std::string& getId() const;
    
private:

    std::string id;
    std::vector<CLAUSE> clauses;
};

}

#endif // KSATINSTANCE_H
